package domainBib;

abstract class Medium {
	private String titel;
	private int erscheinungsjahr;
	private String fälligkeitsDatum;
	private int kennnummer;
	private String autor;
	private String ausleihDatum;
	private int verlängerungen;

	
	abstract public String getTitel();
	abstract public int getJahr();
	abstract public String getAusleihdatum();
	abstract public void setAusleihdatum(String a);
	abstract public int getKennnummer();
	abstract public int getVerlängerungen();
	abstract public void setVerlängerung();
	public String getAutor(){
		return null;
	}
}

class Buch extends Medium{
	private String titel;
	private int erscheinungsjahr;
	private String autor;
	private String fälligkeitsDatum;
	private int kennnummer;
	private String ausleihDatum;
	private int verlängerungen;
	
	public Buch(String titel, int erscheinungsjahr, String autor, int kennnummer) {
		this.titel = titel;
		this.erscheinungsjahr = erscheinungsjahr;
		this.autor = autor; 
		this.fälligkeitsDatum = fälligkeitsDatum;
		this.kennnummer = kennnummer;
		this.verlängerungen = 3;
	}
	
	public String getTitel() {
		return titel;
	}
	
	public int getVerlängerungen() {
		return verlängerungen;
	}

	
	public int getJahr() {
		return erscheinungsjahr;
	}
	
	public String getAutor() {
		return autor;
	}
	
	public void setFälligkeitsDatum(String datum) {
		this.fälligkeitsDatum = datum;
	}
	
	public String getFälligkeitsDatum() {
		return this.fälligkeitsDatum;
	}
	
	public int getKennnummer() {
		return kennnummer;
	}
	
	public String getAusleihdatum() {
		return ausleihDatum;
	}
	
	public void setVerlängerung() {
		verlängerungen--;
	}

	public void setAusleihdatum(String datum) {
		this.ausleihDatum = datum;		
	}
}

class DVD extends Medium{
	private String titel;
	private int erscheinungsjahr;
	private String fälligkeitsDatum;
	private int kennnummer;
	private String autor;
	private String ausleihDatum;
	private int verlängerungen;
	
	public DVD(String titel, int erscheinungsjahr, String fälligkeitsDatum, int kennnummer) {
		this.titel = titel;
		this.erscheinungsjahr = erscheinungsjahr;
		this.fälligkeitsDatum = fälligkeitsDatum;
		this.kennnummer = kennnummer;
		this.autor = null;
		this.verlängerungen = 0;
	}

	public String getTitel() {
		return titel;
	}
	
	public int getJahr() {
		return erscheinungsjahr;
	}
	
	public int getVerlängerungen() {
		return verlängerungen;
	}
	
	public void setAusleihdatum(String datum) {
		this.ausleihDatum = datum;
	}
	
	public void setVerlängerung() {
		verlängerungen =- 1;
	}
	
	public String getAutor() {
		return null;
	}
	
	public String getDatum() {
		return fälligkeitsDatum;
	}
	
	public int getKennnummer() {
		return kennnummer;
	}
	public void setFälligkeitsDatum(String datum) {
		this.fälligkeitsDatum = datum;
	}
	
	public String getFälligkeitsDatum() {
		return this.fälligkeitsDatum;
	}
	
	public String getAusleihdatum() {
		return ausleihDatum;
	}
}

class CD extends Medium{
	private String titel;
	private int erscheinungsjahr;
	private String fälligkeitsDatum;
	private int kennnummer;
	private String autor;
	private String ausleihDatum;
	private int verlängerungen;
	
	public CD(String titel, int erscheinungsjahr, String fälligkeitsDatum, int kennnummer) {
		this.titel = titel;
		this.erscheinungsjahr = erscheinungsjahr;
		this.fälligkeitsDatum = fälligkeitsDatum;
		this.kennnummer = kennnummer;
		this.autor = null;
		this.verlängerungen = 0;

	}
	public void setVerlängerung() {
		verlängerungen =- 1;
	}
	public void setAusleihdatum(String datum) {
		this.ausleihDatum = datum;
	}
	
	public String getTitel() {
		return titel;
	}
	
	public int getJahr() {
		return erscheinungsjahr;
	}
	public String getAutor() {
		return null;
	}
	public int getVerlängerungen() {
		return verlängerungen;
	}
	
	public String getDatum() {
		return fälligkeitsDatum;
	}
	
	public int getKennnummer() {
		return kennnummer;
	}
	public void setFälligkeitsDatum(String datum) {
		this.fälligkeitsDatum = datum;
	}
	
	public String getFälligkeitsDatum() {
		return this.fälligkeitsDatum;
	}
	
	public String getAusleihdatum() {
		return ausleihDatum;
	}
}

class Brettspiel extends Medium{
	private String titel;
	private int erscheinungsjahr;
	private String fälligkeitsDatum;
	private int kennnummer;
	private String autor;
	private String ausleihDatum;
	private int verlängerungen;

	public Brettspiel(String titel, int erscheinungsjahr, String fälligkeitsDatum, int kennnummer) {
		this.titel = titel;
		this.erscheinungsjahr = erscheinungsjahr;
		this.fälligkeitsDatum = fälligkeitsDatum;
		this.kennnummer = kennnummer;
		this.autor = null;
		this.verlängerungen = 0;
	}
	
	public String getTitel() {
		return titel;
	}
	public void setVerlängerung() {
		verlängerungen =- 1;
	}
	
	public int getJahr() {
		return erscheinungsjahr;
	}
	
	public String getAutor() {
		return null;
	}
	
	public String getDatum() {
		return fälligkeitsDatum;
	}
	public int getVerlängerungen() {
		return verlängerungen;
	}
	public int getKennnummer() {
		return kennnummer;
	}
	public void setFälligkeitsDatum(String datum) {
		this.fälligkeitsDatum = datum;
	}
	
	public String getFälligkeitsDatum() {
		return this.fälligkeitsDatum;
	}
	public void setAusleihdatum(String datum) {
		this.ausleihDatum = datum;
	}
	
	public String getAusleihdatum() {
		return ausleihDatum;
	}
}

class Videospiel extends Medium{
	private String titel;
	private int erscheinungsjahr;
	private String fälligkeitsDatum;
	private int kennnummer;
	private String autor;
	private String ausleihDatum;
	private int verlängerungen;

	public Videospiel(String titel, int erscheinungsjahr, String fälligkeitsDatum, int kennnummer) {
		this.titel = titel;
		this.erscheinungsjahr = erscheinungsjahr;
		this.fälligkeitsDatum = fälligkeitsDatum;
		this.kennnummer = kennnummer;
		this.autor = null;
		this.verlängerungen = 1;
	}
	public void setAusleihdatum(String datum) {
		this.ausleihDatum = datum;
	}
	
	public String getTitel() {
		return titel;
	}
	public void setVerlängerung() {
		verlängerungen =- 1;
	}
	
	public int getJahr() {
		return erscheinungsjahr;
	}
	public int getVerlängerungen() {
		return verlängerungen;
	}
	
	public String getAutor() {
		return null;
	}
	
	public String getDatum() {
		return fälligkeitsDatum;
	}
	
	public int getKennnummer() {
		return kennnummer;
	}
	public void setFälligkeitsDatum(String datum) {
		this.fälligkeitsDatum = datum;
	}
	
	public String getFälligkeitsDatum() {
		return this.fälligkeitsDatum;
	}
	
	public String getAusleihdatum() {
		return ausleihDatum;
	}
}