package domainBib;

import java.awt.Component;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.time.temporal.ChronoUnit;
import java.util.ArrayList;
import javax.swing.JLabel;
import guiBib.*;

public class Bibliothek {
		static ArrayList<Buch> bücherListe = new ArrayList<>();
		static ArrayList<CD> cdListe = new ArrayList<>();
		static ArrayList<DVD> dvdListe = new ArrayList<>();
		static ArrayList<Brettspiel> brettspielListe = new ArrayList<>();
		static ArrayList<Videospiel> videospielListe = new ArrayList<>();
		static ArrayList<Kunde> kundenListe = new ArrayList<>();
		static ArrayList<Medium> katalog = new ArrayList<>();
		//static ArrayList<Medium> zurzeitAusgeliehen = new ArrayList<>();
		
	public static void makeEntries() {
		Buch b1 = new Buch("Buch1", 2000, "Autor1", 10001);
		Buch b2 = new Buch("Buch2", 2000, "Autor2",10002);
		Buch b3 = new Buch("Buch3", 2000, "Autor3", 10003);
		Buch b4 = new Buch("Buch4", 2000, "Autor4", 10004);
		Buch b5 = new Buch("Buch5", 2000, "Autor5", 10005);
		bücherListe.add(b1);
		bücherListe.add(b2);
		bücherListe.add(b3);
		bücherListe.add(b4);
		bücherListe.add(b5);
		
		DVD d1 = new DVD("DVD1", 2000, "01.01.2020", 20001);
		DVD d2 = new DVD("DVD2", 2000, "01.01.2020", 20002);
		DVD d3 = new DVD("DVD3", 2000, "01.01.2020", 20003);
		DVD d4 = new DVD("DVD4", 2000, "01.01.2020", 20004);
		DVD d5 = new DVD("DVD5", 2000, "01.01.2020", 20005);
		dvdListe.add(d1);
		dvdListe.add(d2);
		dvdListe.add(d3);
		dvdListe.add(d4);
		dvdListe.add(d5);
		
		CD c1 = new CD("CD1", 2000, "01.01.2020", 30001);
		CD c2 = new CD("CD2", 2000, "01.01.2020", 30002);
		CD c3 = new CD("CD3", 2000, "01.01.2020", 30003);
		CD c4 = new CD("CD4", 2000, "01.01.2020", 30004);
		CD c5 = new CD("CD5", 2000, "01.01.2020", 30005);
		cdListe.add(c1);
		cdListe.add(c2);
		cdListe.add(c3);
		cdListe.add(c4);
		cdListe.add(c5);
		
		Brettspiel bs1 = new Brettspiel("Brettspiel1", 2000, "01.01.2020", 40001);
		Brettspiel bs2 = new Brettspiel("Brettspiel2", 2000, "01.01.2020", 40002);
		Brettspiel bs3 = new Brettspiel("Brettspiel3", 2000, "01.01.2020", 40003);
		Brettspiel bs4 = new Brettspiel("Brettspiel4", 2000, "01.01.2020", 40004);
		Brettspiel bs5 = new Brettspiel("Brettspiel5", 2000, "01.01.2020", 40005);
		brettspielListe.add(bs1);
		brettspielListe.add(bs2);
		brettspielListe.add(bs3);
		brettspielListe.add(bs4);
		brettspielListe.add(bs5);
		
		Videospiel v1 = new Videospiel("Videospiel1", 2000, "01.01.2020", 50001);
		Videospiel v2 = new Videospiel("Videospiel2", 2000, "01.01.2020", 50002);
		Videospiel v3 = new Videospiel("Videospiel3", 2000, "01.01.2020", 50003);
		Videospiel v4 = new Videospiel("Videospiel4", 2000, "01.01.2020", 50004);
		Videospiel v5 = new Videospiel("Videospiel5", 2000, "01.01.2020", 50005);
		videospielListe.add(v1);
		videospielListe.add(v2);
		videospielListe.add(v3);
		videospielListe.add(v4);
		videospielListe.add(v5);
		
		Kunde k1 = new Kunde(true, 1);
		Kunde k2 = new Kunde(true, 2);
		Kunde k3 = new Kunde(false, 3);
		Kunde k4 = new Kunde(false, 4);
		Kunde k5 = new Kunde(false, 5);
		kundenListe.add(k1);
		kundenListe.add(k2);
		kundenListe.add(k3);
		kundenListe.add(k4);
		kundenListe.add(k5);
		
		for(Buch b: bücherListe) {
		katalog.add(b);
		}
		for(DVD d: dvdListe) {
			katalog.add(d);
		}
		for(CD c: cdListe) {
			katalog.add(c);
		}
		for(Brettspiel bs: brettspielListe) {
			katalog.add(bs);
		}
		for(Videospiel vs: videospielListe) {
			katalog.add(vs);
			}
	}
	
	public static Kunde validateLogin(int login) {
		for(Kunde k: kundenListe) {
			if(k.getKennnummer() == login) {
				return k;
			}
		}
		return null;
	}

	public static ArrayList<JLabel> buchAuflisten() {
		ArrayList<JLabel> jlabelList = new ArrayList<>();
		if(bücherListe.size() == 0) {
			JLabel text = new JLabel("Keine Bücher mehr vorhanden.");
			jlabelList.add(text);
			return jlabelList;
		}
		for(Buch b: bücherListe) {
			JLabel buch = new JLabel("Titel: " + b.getTitel()
					+ ", Autor: " +  b.getAutor()
					+ ", Jahr: " + b.getJahr()
					+ ", Kennnummer: " + b.getKennnummer());
			jlabelList.add(buch);
		}
		return jlabelList;
	}

	public static ArrayList<JLabel> dvdAuflisten() {
		ArrayList<JLabel> jlabelList = new ArrayList<>();
		if(dvdListe.size() == 0) {
			JLabel text = new JLabel("Keine DVDs mehr vorhanden.");
			jlabelList.add(text);
			return jlabelList;
		}
		for(DVD d: dvdListe) {
			JLabel dvd = new JLabel("Titel: " + d.getTitel()
					+ ", Jahr: " + d.getJahr()
					+ ", Kennnummer: " + d.getKennnummer());
			jlabelList.add(dvd);
		}
		return jlabelList;
	}
	
	public static ArrayList<JLabel> cdAuflisten() {
		ArrayList<JLabel> jlabelList = new ArrayList<>();
		if(cdListe.size() == 0) {
			JLabel text = new JLabel("Keine CDs mehr vorhanden.");
			jlabelList.add(text);
			return jlabelList;
		}
		for(CD c: cdListe) {
			JLabel cd = new JLabel("Titel: " + c.getTitel()
					+ ", Jahr: " + c.getJahr()
					+ ", Kennnummer: " + c.getKennnummer());
			jlabelList.add(cd);
		}
		return jlabelList;
	}
	
	public static ArrayList<JLabel> bsAuflisten() {
		ArrayList<JLabel> jlabelList = new ArrayList<>();
		if(brettspielListe.size() == 0) {
			JLabel text = new JLabel("Keine Brettspiele mehr vorhanden.");
			jlabelList.add(text);
			return jlabelList;
		}
		for(Brettspiel bs: brettspielListe) {
			JLabel bsp = new JLabel("Titel: " + bs.getTitel()
					+ ", Jahr: " + bs.getJahr()
					+ ", Kennnummer: " + bs.getKennnummer());
			jlabelList.add(bsp);
		}
		return jlabelList;
	}
	
	public static ArrayList<JLabel> vsAuflisten() {
		ArrayList<JLabel> jlabelList = new ArrayList<>();
		if(videospielListe.size() == 0) {
			JLabel text = new JLabel("Keine Videospiele mehr vorhanden.");
			jlabelList.add(text);
			return jlabelList;
		}
		for(Videospiel v: videospielListe) {
			JLabel vsp = new JLabel("Titel: " + v.getTitel()
					+ ", Jahr: " + v.getJahr()
					+ ", Kennnummer: " + v.getKennnummer());
			jlabelList.add(vsp);
		}
		return jlabelList;
	}

	public static ArrayList<JLabel> ausgelieheneListe(Kunde k) {
		ArrayList<JLabel> jlabelList = new ArrayList<>();
		ArrayList<Medium> ausgelieheneListe = k.returnAusgelieheneMedien();
		if(ausgelieheneListe.size() == 0) {
			JLabel text = new JLabel("Nichts ausgeliehen.");
			jlabelList.add(text);
			return jlabelList;
		}
		for(Medium m: ausgelieheneListe) {
 			if(m.getAutor() != null) {
				JLabel med = new JLabel("Titel: " + m.getTitel() 
					+ ", Autor: " + m.getAutor()
					+ ", Jahr: " + m.getJahr()
					+ ", Kennnummer: " + m.getKennnummer()
					+ ", ausgeliehen am: " + m.getAusleihdatum()
					+ ", Verlängerungen: " + m.getVerlängerungen());
					jlabelList.add(med);
			}
				if(m.getAutor() == null) {
				JLabel med = new JLabel("Titel: " + m.getTitel() 
					+ ", Jahr: " + m.getJahr()
					+ ", Kennnummer: " +m.getKennnummer()
				    + ", ausgeliehen am: " + m.getAusleihdatum()
				    + ", Verlängerungen: " + m.getVerlängerungen());
					jlabelList.add(med);
				}	
		}
		return jlabelList;
	}

	public static void ausleihe(int kennnummer, String datum, Kunde k) {
		for(Medium m: katalog) {
			if(m.getKennnummer() == kennnummer) {
				String text = m.getClass().toString();
				int lastDotIndex = text.lastIndexOf(".");
				String substring = text.substring(lastDotIndex + 1);
				switch (substring) {
				case "Buch":
							Buch b = (Buch) m;
							b.setAusleihdatum(datum);
							bücherListe.remove(b);
							k.addToList(b);
					break;
				case "DVD":
							DVD d = (DVD) m;
							d.setAusleihdatum(datum);
							dvdListe.remove(d);
							k.addToList(d);
					break;
				case "CD":
							CD c = (CD) m;
							c.setAusleihdatum(datum);
							cdListe.remove(c);
							k.addToList(c);
					break;
				case "Brettspiel":
							Brettspiel bs = (Brettspiel) m;
							bs.setAusleihdatum(datum);
							brettspielListe.remove(bs);
							k.addToList(bs);
					break;
				case "Videospiel":
							Videospiel vs = (Videospiel) m;
							vs.setAusleihdatum(datum);
							videospielListe.remove(vs);
							k.addToList(vs);
					break;
				default:
					break;
				}
				
			}
		}
	}

	public static void rückgabe(int kennnummer, String rückgabeDatum, Kunde k) {
		for(Medium m: katalog) {
			if(m.getKennnummer() == kennnummer) {
				String text = m.getClass().toString();
				int lastDotIndex = text.lastIndexOf(".");
				String substring = text.substring(lastDotIndex + 1);
				switch (substring) {
				case "Buch":
						Buch b = (Buch) m;
						double kostenBuch = berechneGebühren(b, kennnummer, rückgabeDatum);
						String titelBuch = b.getTitel();
						if(kostenBuch>0) {BibliothekGUI.zahlungsFenster(kostenBuch, titelBuch, kennnummer, k);
						bücherListe.add(b);
						k.removeFromList(m);
						} else {
						bücherListe.add(b);
						k.removeFromList(m);
						BibliothekGUI.noMoneyOwed();
						}
					break;
				case "DVD":
						DVD d = (DVD) m;
						double kostenDVD = berechneGebühren(d, kennnummer, rückgabeDatum);
						String titelDVD = d.getTitel();
						if(kostenDVD>0) {BibliothekGUI.zahlungsFenster(kostenDVD, titelDVD, kennnummer, k);
						dvdListe.add(d);
						k.removeFromList(m);
						} else {
						dvdListe.add(d);
						k.removeFromList(m);
						BibliothekGUI.noMoneyOwed();
						}
					break;
				case "CD":
						CD c = (CD) m;
						double kostenCD = berechneGebühren(c, kennnummer, rückgabeDatum);
						String titelCD = c.getTitel();
						if(kostenCD>0) {BibliothekGUI.zahlungsFenster(kostenCD, titelCD, kennnummer, k);
						cdListe.add(c);
						k.removeFromList(m);
						} else {
						cdListe.add(c);
						k.removeFromList(m);
						BibliothekGUI.noMoneyOwed();
						}
					break;
				case "Brettspiel":
						Brettspiel bs = (Brettspiel) m;
						double kostenBS = berechneGebühren(bs, kennnummer, rückgabeDatum);
						String titelBS = bs.getTitel();
						if(kostenBS>0) {BibliothekGUI.zahlungsFenster(kostenBS, titelBS, kennnummer, k);
						brettspielListe.add(bs);
						k.removeFromList(m);
						} else {
						brettspielListe.add(bs);
						k.removeFromList(m);
						BibliothekGUI.noMoneyOwed();
						}
					break;
				case "Videospiel":
						Videospiel vs = (Videospiel) m;
						double kostenVS = berechneGebühren(vs, kennnummer, rückgabeDatum);
						String titelVS = vs.getTitel();
						if(kostenVS>0) {BibliothekGUI.zahlungsFenster(kostenVS, titelVS, kennnummer, k);
						videospielListe.add(vs);
						k.removeFromList(m);
						} else {
						videospielListe.add(vs);
						k.removeFromList(m);
						BibliothekGUI.noMoneyOwed();
						}
					break;
				default:
					break;
				}
				
			}
		}
	}
	
	private static double berechneGebühren(Buch b, int kennnummer, String rückgabeDatum) {
		String ausleihDatum = b.getAusleihdatum();
		double tageAusgeliehen = findDifference(ausleihDatum, rückgabeDatum);
		double kosten = 0;
		if(tageAusgeliehen <= 28) {
			return kosten = 0;
		}
		int dayCounter = 0;
		while(tageAusgeliehen > 28) {
			if(dayCounter >=8) {
				kosten += 2;
				dayCounter++;
				tageAusgeliehen--;
			}else if (dayCounter <= 7){
			kosten += 1;
			dayCounter++;
			tageAusgeliehen--;
			}
		}
		return kosten;
	}
	
	private static double berechneGebühren(DVD d, int kennnummer, String rückgabeDatum) {
		String ausleihDatum = d.getAusleihdatum();
		double tageAusgeliehen = findDifference(ausleihDatum, rückgabeDatum);
		double kosten = 0;
		if(tageAusgeliehen <= 7) {
			return kosten = 0;
		}
		int dayCounter = 0;
		while(tageAusgeliehen >= 8) {
			if(dayCounter >=8) {
				kosten += 2;
				dayCounter++;
				tageAusgeliehen--;
			}else if (dayCounter <= 7){
			kosten += 1;
			dayCounter++;
			tageAusgeliehen--;
			}
		}
		return kosten;
	}
	
	private static double berechneGebühren(CD c, int kennnummer, String rückgabeDatum) {
		String ausleihDatum = c.getAusleihdatum();
		double tageAusgeliehen = findDifference(ausleihDatum, rückgabeDatum);
		double kosten = 0;
		if(tageAusgeliehen <= 14) {
			return kosten = 0;
		}
		int dayCounter = 0;
		while(tageAusgeliehen >= 15) {
			if(dayCounter >=8) {
				kosten += 2;
				dayCounter++;
				tageAusgeliehen--;
			}else if (dayCounter <= 7){
			kosten += 1;
			dayCounter++;
			tageAusgeliehen--;
			}
		}
		return kosten;
	}
	
	private static double berechneGebühren(Brettspiel bs, int kennnummer, String rückgabeDatum) {
		String ausleihDatum = bs.getAusleihdatum();
		double tageAusgeliehen = findDifference(ausleihDatum, rückgabeDatum);
		double kosten = 0;
		if(tageAusgeliehen <= 14) {
			return kosten = 0;
		}
		int dayCounter = 0;
		while(tageAusgeliehen >= 15) {
			if(dayCounter >=8) {
				kosten += 2;
				dayCounter++;
				tageAusgeliehen--;
			}else if (dayCounter <= 7){
			kosten += 1;
			dayCounter++;
			tageAusgeliehen--;
			}
		}
		return kosten;
	}
	
	private static double berechneGebühren(Videospiel vs, int kennnummer, String rückgabeDatum) {
		String ausleihDatum = vs.getAusleihdatum();
		double tageAusgeliehen = findDifference(ausleihDatum, rückgabeDatum);
		double kosten = 0;
		if(tageAusgeliehen <= 28) {
			return kosten = 0;
		}
		int dayCounter = 0;
		while(tageAusgeliehen >= 29) {
			if(dayCounter >=8) {
				kosten += 2;
				dayCounter++;
				tageAusgeliehen--;
			}else if (dayCounter <= 7){
			kosten += 1;
			dayCounter++;
			tageAusgeliehen--;
			}
		}
		return kosten;
	}
	
	public static boolean zahlungRegistrieren(int zahlung, double kosten) {
		boolean isTrue = false; 
		if(kosten - zahlung <= 0) {
			isTrue = true;
		} else {
			isTrue = false;
		}
		return isTrue;
	}

	private static double findDifference(String ausleihDatum, String rückgabeDatum) {
		LocalDate ausgeliehenTag = LocalDate.parse(ausleihDatum, DateTimeFormatter.ofPattern("dd.MM.yyyy"));
		LocalDate rückgabeTag = LocalDate.parse(rückgabeDatum, DateTimeFormatter.ofPattern("dd.MM.yyyy"));
		double differenzInTagen = ChronoUnit.DAYS.between(ausgeliehenTag, rückgabeTag);
		return differenzInTagen;
	}

	public static int bücherLänge() {
		return bücherListe.size();
	}
	
	public static int dvdLänge() {
		return dvdListe.size();
	}
	
	public static int cdLänge() {
		return cdListe.size();
	}
	
	public static int bsLänge() {
		return brettspielListe.size();
	}
	
	public static int vsLänge() {
		return videospielListe.size();
	}

	public static int getUserListLength() {
		return kundenListe.size();
	}

	public static ArrayList<JLabel> nutzerAuflisten() {
		ArrayList<JLabel> jlabelList = new ArrayList<>();
		if(kundenListe.size() == 0) {
			JLabel text = new JLabel("Keine Nutzer registriert."); 
			jlabelList.add(text);
			return jlabelList;
		}
		for(Kunde k: kundenListe) {
			JLabel cd = new JLabel("Kennnummer: " + k.getKennnummer()
					+ ", Student: " + k.istStudent()
					+ ", Schulden: " + k.getSchulden());
			jlabelList.add(cd);
		}
		return jlabelList;
	}

	public static int getNewKennnummer() {
		int newKennnummer = 0;
		for(Kunde k: kundenListe) {
			int nummer = k.getKennnummer();
			if(nummer > newKennnummer) {
				newKennnummer = nummer;
			}
		}
		newKennnummer += 1;
		return newKennnummer;
	}

	public static void addCustomer(Kunde k) {
		kundenListe.add(k);
	}

	public static boolean verlängerungMöglich(int kennnummer, Kunde k) {
		ArrayList<Medium> ausgeliehenListe = k.returnAusgelieheneMedien();
		for(Medium m: ausgeliehenListe) {
			if(m.getKennnummer() == kennnummer) {
					if(m.getVerlängerungen() > 0) {
						m.setVerlängerung();
						datumVerlängern(m, k);
						return true;
					} else {
						return false;
					}
			}
		}
	return false;
	}

	private static void datumVerlängern(Medium m, Kunde k) {
		String text = m.getClass().toString();
		int lastDotIndex = text.lastIndexOf(".");
		String substring = text.substring(lastDotIndex + 1);
		String ausleihDatum = m.getAusleihdatum();
		DateTimeFormatter formatter = DateTimeFormatter.ofPattern("dd.MM.yyyy");
		LocalDate ausgeliehenTag = LocalDate.parse(ausleihDatum, formatter);
		LocalDate neuerTag = ausgeliehenTag.plusDays(28);
		String neuesAusleihDatum = neuerTag.format(formatter);
		m.setAusleihdatum(neuesAusleihDatum);
	}

	public static void changeOwedMenu2(String kennnummerStr, int amount) {
		int kennnummer = Integer.parseInt(kennnummerStr);
			for(Kunde k: kundenListe) {
				if(k.getKennnummer() == kennnummer) {
					k.setSchulden(amount);
				}
			}
	}
	
	
}

	
	

