package domainBib;

import java.util.ArrayList;

public class Kunde extends Benutzer {
	private int kennnummer;
	private boolean istStudent;
	private double schulden;
	private ArrayList<Medium> ausgelieheneMedien = new ArrayList<>();
		
	public Kunde(boolean istStudent, int kennnummer) {
		this.istStudent = istStudent;
		this.kennnummer = kennnummer;
		this.schulden = 0;
	}
	
	public int getKennnummer() {
		return kennnummer;
	}
	
	public void setSchulden(double a) {
		schulden = a;
	}
	
	public void addSchulden(double b) {
		schulden += b; 
	}
	
	public double getSchulden(){
		return schulden; 
	}
	
	public void addToList(Medium m) {
		ausgelieheneMedien.add(m);
	}
	
	public boolean istStudent() {
		return istStudent;
	}
	
	public ArrayList<Medium> returnAusgelieheneMedien(){
		return ausgelieheneMedien;
	}
	
	public int ausgelieheneMedienLänge() {
		return ausgelieheneMedien.size();
	}

	public void removeFromList(Medium m) {
		ausgelieheneMedien.remove(m);
	}
}
